#include "MMCDemo.h"
#include "mmc.h"
#include "stm32f4xx_gpio.h"
#include <string.h>
#include "bits.h"

// mmc variable
extern char mmc_buffer[512];
char mmc_buffer_test_1[512];

// ext variable
char state_ext = 1;
char i=0;

unsigned char CardIsPresent(void);

static GPIO_InitTypeDef GPIO_InitStructure;

void DelayN (unsigned long a) { while (--a!=0); }

unsigned char CardPresent (void)
{
  RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOC, ENABLE);

  // CP
  GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_7;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(GPIOC, &GPIO_InitStructure);

  while (1)
  if((GPIO_ReadInputDataBit(GPIOC, GPIO_Pin_7)) == Bit_SET)
    return 0; // Card present
  else
    return 1;
}

unsigned char CardWriteProtect (void)
{
  RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOC, ENABLE);

  // WP
  GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_6;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(GPIOC, &GPIO_InitStructure);

  if((GPIO_ReadInputDataBit(GPIOC, GPIO_Pin_6)) == Bit_SET)
    return 0; // Card not protected
  else
    return 1;
}

// MMC ======================================================================================
unsigned char DemoMMC(void)
{

  // return value - 0 - mmc card ok
  // return value - 1 - mmc error
  // return value - 2 - mmc card not present
  // return value - 3 - mmc card write protected
  
  // Enable clock
  RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB, ENABLE);
  
  // CP
  if (CardPresent ())
    return 2; // Card not present
  
  // WP
  if (CardWriteProtect ())
    return 3; // Card write protected

  if (initMMC() == MMC_SUCCESS)	// card found
  {
    //card_state |= 1;
    memset(&mmc_buffer,0,512);
    mmcReadRegister (10, 16);
    mmc_buffer[7]=0;

    // Fill first Block (0) with 'A'
    memset(&mmc_buffer,'0',512);    //set breakpoint and trace mmc_buffer contents
    mmcWriteBlock(0);
    // Fill second Block (1)-AbsAddr 512 with 'B'
    memset(&mmc_buffer,'1',512);
    mmcWriteBlock(512);

    // Read first Block back to buffer
    memset(&mmc_buffer,0x00,512);
    mmcReadBlock(0,512);
    memset(&mmc_buffer_test_1,'0',512);
    if(strncmp(&mmc_buffer[0], &mmc_buffer_test_1[0], 512))
       return 1;

    // Read first Block back to buffer
    memset(&mmc_buffer,0x00,512);
    mmcReadBlock(512,512);
    memset(&mmc_buffer_test_1,'1',512);
    if(strncmp(&mmc_buffer[0], &mmc_buffer_test_1[0], 512))
       return 1;

    memset(&mmc_buffer,0x00,512);
  }

  return 0;
}
